from __future__ import with_statement
from fabric.api import *
from fabric.contrib.console import confirm
from fabric.contrib.files import exists
from fabric.context_managers import prefix
import operator

env.hosts = ['198.199.109.50']
env.user = 'root'


def deploy():
    """
    fab deploy
    """
    
    env.env_bin = '/home/ralph/djsites/.virtualenvs/potato_env/bin'
    env.env_dir = '/home/ralph/djsites/potato_test/src/potato_project'

    def pull():
        if confirm('Are you sure to pull source code from repository?'):
            run('hg pull; hg update')
            run('find ./ -name "*.pyc" -delete')

    def daemon():
        run(env.env_bin + "/pip freeze")

        if confirm("Install project pip requirements?"):
            run(env.env_bin + "/pip install -r ./requirements.txt")
            
        if confirm("Run DB Migration? WARNING: Prone to failure!"):
            run(env.env_bin + "/python ./manage.py migrate")

        if confirm("Run Sync DB? WARNING: Reset some data!"):
            run(env.env_bin + "/python ./manage.py syncdb")

        if confirm("Run Collect Static? WARNING: Replace existing assets file!"):
            run(env.env_bin + "/python ./manage.py collectstatic")

        run('invoke-rc.d initd.conf.sh reload')
