import urllib2

# Create your views here.
from django.shortcuts import render
from django.template import RequestContext
from django.utils import simplejson

from profiles.models import Profile
from photos.forms import PhotoForm
from photos.models import GadgetModel, Photo

from socialregistration.contrib.facebook.models import FacebookAccessToken, FacebookProfile


def home(request, template_name="home.html"):
    """
    Public home page
    dict or {} is reserve if context is needed for additional functionalities

    More details:
    ...
    """
    gadgets = GadgetModel.objects.all().order_by('name')
    form = PhotoForm()
    if request.user.is_authenticated:
        try:
            if FacebookProfile.objects.filter(user=request.user):
                if not request.user.email:
                    fb = FacebookAccessToken.objects.get(profile=FacebookProfile.objects.get(user=request.user))
                    url = 'https://graph.facebook.com/me?access_token=%s' % (fb.access_token)
                    try:
                        get_url = urllib2.urlopen(url)
                        fb_json = simplejson.load(get_url)
                        profile, create = Profile.objects.get_or_create(user=request.user)
                        profile.first_name = fb_json['first_name']
                        profile.last_name = fb_json['last_name']
                        profile.link = fb_json['link']
                        profile.save()
                        user = request.user
                        user.email = str(fb_json['email']).replace('\u0040', '@')
                        user.save()
                    except Exception, e:
                        print str(e)
        except Exception:
            pass

    return render(request, template_name, {
                                           'form': form,
                                           'gadgets': gadgets,
                                       },
                  context_instance=RequestContext(request))