from django.contrib import admin

from photos.models import Photo, Brand, GadgetModel, PhotoSpec

class PhotoSpecInline(admin.TabularInline):
    model = PhotoSpec

class PhotoAdmin(admin.ModelAdmin):
    list_display = ('photo', 'user', 'gadget_model',)
    search_fields = ('user__username', 'photo', 'gadget_model', 'gadget_model__brand')
    list_filter = ["gadget_model", "gadget_model__brand"]
    inlines = [
        PhotoSpecInline,
    ]

admin.site.register(Photo, PhotoAdmin)

class GadgetModelAdmin(admin.ModelAdmin):
    list_display = ('name', 'brand',)
    search_fields = ('name', 'brand',)
    list_filter = ["brand",]

admin.site.register(GadgetModel, GadgetModelAdmin)

admin.site.register(Brand)