import os
import datetime
import ast

from django.db import models
from django.contrib.auth.models import User
# Create your models here.


def photo_file_path(instance, filename=None):
    """
    Store the folder for photos
    """
    return os.path.join('photos/%s' % (datetime.date.today()), filename)


class Brand(models.Model):
    """
    Brand of device
    """
    name = models.CharField(max_length=200, blank=False, null=False)

    def __unicode__(self):
        return self.name


class GadgetModel(models.Model):
    """
    Get the model name of device
    """
    brand = models.ForeignKey(Brand)
    name = models.CharField(max_length=200, blank=False, null=False)

    def photos(self):
        return Photo.objects.filter(gadget_model=self)

    def __unicode__(self):
        return self.name


class Photo(models.Model):
    """
    Upload photo of user
    """
    user = models.ForeignKey(User)
    gadget_model = models.ForeignKey(GadgetModel, null=True, blank=True)
    photo = models.ImageField(upload_to=photo_file_path)
    date_added = models.DateTimeField(auto_now_add=True, editable=False)

    class Meta:
        ordering = ['-date_added']

    def gadget_json(self):
        x = str(self.data)
        d = ast.literal_eval(x)
        print d
        return d

    def photo_data(self):
        return PhotoSpec.objects.filter(photo=self)


class PhotoSpec(models.Model):
    """
    Get key and value from photo
    """
    name = models.CharField(max_length=100, blank=False)
    value = models.TextField(blank=False)
    photo = models.ForeignKey(Photo)
