from django.db import models
from django.utils.translation import ugettext_lazy as _
from django.contrib.auth.models import User
# Create your models here.


class Profile(models.Model):
    """
    User profile model
    """
    user = models.ForeignKey(User, unique=True)
    first_name = models.CharField(_("first name"), max_length=75, null=False)
    last_name = models.CharField(_("last name"), max_length=75, null=False)
    location = models.CharField(_("location"), max_length=100, null=False)
    link = models.URLField(blank=False)
    username = models.CharField(max_length=300, blank=True)

    def __unicode__(self):
        if self.first_name and self.last_name:
            return "%s %s" % (self.first_name, self.last_name)
        return self.user.username
